> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://reference.flatfile.com/api-reference/files/update/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server. # Update a file PATCH https://api.x.flatfile.com/v1/files/{fileId} Content-Type: application/json Update a file, to change the workbook id for example Reference: https://reference.flatfile.com/api-reference/files/update ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `fileId` (string, required) — ID of file to update ### Body (application/json) This endpoint expects an object. - `workbookId` (string, optional) — Workbook ID - `name` (string, optional) — The name of the file - `mode` (enum, optional) — The storage mode of file to update - Allowed values: `import`, `export` - `status` (enum, optional) — Status of the file. Partial: File is uploaded but not yet processed. Analyzing: Smart Extract is running. Analyzed: Smart Extract has finished running. Complete: File has been extracted and is ready to be used. Archived: File has been archived. Purged: File has been purged. Failed: File has failed to be extracted. - Allowed values: `partial`, `analyzing`, `analyzed`, `complete`, `archived`, `purged`, `failed` - `actions` (list of Action, optional) — The actions attached to the file ## Response ### 200 - `data` (File, required) — Any uploaded file of any type ## Errors ### 400 Bad Request Error - `errors` (list of Error, required) ### 404 Not Found Error - `errors` (list of Error, required) ## Types ### Action - `label` (string, required) — The text on the Button itself - `confirm` (boolean, optional) — Whether to show a modal to confirm the action - `constraints` (list of ActionConstraint, optional) — A limitation or restriction on the action. - `createdFrom` (string, optional) — The action that this action was cloned from - `deletedAt` (datetime, optional) — The time this action was deleted - `description` (string, optional) — The text that appears in the dialog after the action is clicked. - `guardrail` (Guardrail, optional) - `guide` (Guide, optional) - `icon` (string, optional) — Icon will work on primary actions. It will only accept an already existing Flatfile design system icon. - `inputForm` (InputForm, optional) — Adds an input form for this action after it is clicked. - `invalidConditionalMessaging` (boolean, optional) — When enabled, shows dynamic confirmation messages based on record validation status instead of the static description - `invalidRecordsMessage` (string, optional) — Custom message to show when there are invalid records (only used when invalidConditionalMessaging is true) - `lastPropagatedAt` (datetime, optional) — The last time this action was propagated to a workbook - `messages` (list of ActionMessage, optional) - `mode` (enum, optional) — Foreground and toolbarBlocking action mode will prevent interacting with the resource until complete - Allowed values: `foreground`, `background`, `toolbarBlocking` - `mount` (ActionMount, optional) - `operation` (string, optional) — This will become the job operation that is triggered - `primary` (boolean, optional) — A primary action will be more visibly present, whether in Sheet or Workbook. - `schedule` (enum, optional) — Determines if the action should happen on a regular cadence. - Allowed values: `weekly`, `daily`, `hourly` - `tooltip` (string, optional) — A tooltip that appears when hovering the action button - `type` (string, optional) — **This is deprecated.** - `validRecordsMessage` (string, optional) — Custom message to show when all records are valid (only used when invalidConditionalMessaging is true) - `requireAllValid` (boolean, optional, deprecated) — **This is deprecated. Use `constraints` instead.** - `requireSelection` (boolean, optional, deprecated) — **This is deprecated. Use `constraints` instead.** - `slug` (string, optional, deprecated) — **This is deprecated. Use `operation` instead.** ### File Any uploaded file of any type - `id` (string, required) — File ID - `name` (string, required) — Original filename - `ext` (string, required) — Extension of the file - `mimetype` (string, required) — MIME Type of the file - `encoding` (string, required) — Text encoding of the file - `status` (enum, required) — Status of the file. Partial: File is uploaded but not yet processed. Analyzing: Smart Extract is running. Analyzed: Smart Extract has finished running. Complete: File has been extracted and is ready to be used. Archived: File has been archived. Purged: File has been purged. Failed: File has failed to be extracted. - Allowed values: `partial`, `analyzing`, `analyzed`, `complete`, `archived`, `purged`, `failed` - `size` (integer, required) — Size of file in bytes - `bytesReceived` (integer, required) — Number of bytes that have been uploaded so far (useful for progress tracking) - `createdAt` (datetime, required) — Date the file was created - `updatedAt` (datetime, required) — Date the file was last updated - `spaceId` (string, required) — Space ID - `description` (string, optional) — Description of the file - `mode` (enum, optional) — The storage mode of file - Allowed values: `import`, `export` - `expiredAt` (datetime, optional) — Date the file was expired - `workbookId` (string, optional) — Workbook ID - `sheetId` (string, optional) — Sheet ID - `actions` (list of Action, optional) - `origin` (enum, optional) - Allowed values: `filesystem`, `googledrive`, `box`, `onedrive` - `treatments` (list of enum, optional) - Allowed values: `IS_BASIC_FILE_SHAPE`, `IS_COMPLEX_FILE_SHAPE` ### Error - `message` (string, required) - `key` (string, optional) ### ActionConstraint - `type`: `hasAllValid` - `ignoreSelection` (boolean, optional) - `type`: `hasSelection` - `type`: `hasData` - `type`: `hasColumnEnabled` ### Guardrail - `content` (string, required) — Markdown guardrail for this action ### Guide - `content` (string, required) — Markdown guidance for this action ### InputForm - `type` (enum, required) - Allowed values: `simple` - `fields` (list of InputField, required) ### ActionMessage - `type` (enum, required) - Allowed values: `error`, `info` - `content` (string, required) ### ActionMount - `type`: `sheet` - `slugs` (list of string, optional) - `type`: `workbook` - `slugs` (list of string, optional) - `type`: `field` - `keys` (list of string, optional) - `type`: `document` - `type`: `file` ### InputField - `key` (string, required) — Unique key for a Field. - `label` (string, required) — Visible name of a Field. - `type` (string, required) — Field Types inform the user interface how to sort and display data. - `description` (string, optional) — Brief description below the name of the Field. - `defaultValue` (any, optional) — Default value for a Field. - `config` (InputConfig, optional) — Additional configuration for enum Fields. - `constraints` (list of InputConstraint, optional) — Indicate additional validations that will be applied to the Field. ### InputConfig - `options` (list of InputEnumPropertyOption, required) ### InputConstraint - `type` (enum, required) - Allowed values: `required` ### InputEnumPropertyOption - `value` (any, required) — The value or ID of this option. This value will be sent in egress. The type is a string | integer | boolean. - `label` (string, optional) — A visual label for this option, defaults to value if not provided - `description` (string, optional) — A short description for this option - `color` (string, optional) — An optional color to assign this option - `icon` (string, optional) — A reference pointer to a previously registered icon - `meta` (map from string to any, optional) — An arbitrary JSON object to be associated with this option and made available to hooks ## Examples **Request** ```json { "name": "NewFileName" } ``` **Response** ```json { "data": { "id": "us_fl_YOUR_ID", "name": "NewFileName", "ext": "csv", "mimetype": "text/csv", "encoding": "7bit", "status": "partial", "size": 81953, "bytesReceived": 81593, "createdAt": "2023-11-15T19:31:33.015Z", "updatedAt": "2023-11-15T19:31:33.015Z", "spaceId": "us_sp_YOUR_ID", "description": "This is a new test file", "mode": "import" } } ``` **SDK Code** ```python Example0 import requests url = "https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID" payload = { "name": "NewFileName" } headers = { "X-Disable-Hooks": "true", "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.patch(url, json=payload, headers=headers) print(response.json()) ``` ```typescript Example0 import { FlatfileClient } from "@flatfile/api"; const client = new FlatfileClient({ token: "YOUR_TOKEN" }); await client.files.update("us_fl_YOUR_ID", { name: "NewFileName" }); ``` ```go Example0 package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID" payload := strings.NewReader("{\n \"name\": \"NewFileName\"\n}") req, _ := http.NewRequest("PATCH", url, payload) req.Header.Add("X-Disable-Hooks", "true") req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Example0 require 'uri' require 'net/http' url = URI("https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Patch.new(url) request["X-Disable-Hooks"] = 'true' request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"NewFileName\"\n}" response = http.request(request) puts response.read_body ``` ```java Example0 import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.patch("https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID") .header("X-Disable-Hooks", "true") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"name\": \"NewFileName\"\n}") .asString(); ``` ```php Example0 request('PATCH', 'https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID', [ 'body' => '{ "name": "NewFileName" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', 'X-Disable-Hooks' => 'true', ], ]); echo $response->getBody(); ``` ```csharp Example0 using RestSharp; var client = new RestClient("https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID"); var request = new RestRequest(Method.PATCH); request.AddHeader("X-Disable-Hooks", "true"); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"NewFileName\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Example0 import Foundation let headers = [ "X-Disable-Hooks": "true", "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["name": "NewFileName"] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/files/us_fl_YOUR_ID")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PATCH" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```